// ReadWriteLockTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ReadWriteLockTest.h"
#include "ReadWriteLockTestDlg.h"
#include "AdditionalThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReadWriteLockTestDlg dialog

CReadWriteLockTestDlg::CReadWriteLockTestDlg(BOOL bMainThread, CWnd* pParent /*=NULL*/)
:
CDialog(CReadWriteLockTestDlg::IDD, pParent),
m_bMainThread(bMainThread)
{
	m_ReadLocks = 0;
    m_WriteLocks = 0;
    //{{AFX_DATA_INIT(CReadWriteLockTestDlg)
	m_ThreadType = _T("");
	m_State = _T("");
	m_Timeout = 5000;
	m_ReadLocksStr = _T("");
	m_WriteLocksStr = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReadWriteLockTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReadWriteLockTestDlg)
	DDX_Text(pDX, IDC_THREAD_TYPE, m_ThreadType);
	DDX_Text(pDX, IDC_STATE, m_State);
	DDX_Text(pDX, IDC_TIMEOUT, m_Timeout);
	//}}AFX_DATA_MAP

    m_ReadLocksStr.Format("%d", m_ReadLocks);
	DDX_Text(pDX, IDC_READ_LOCKS, m_ReadLocksStr);

    m_WriteLocksStr.Format("%d", m_WriteLocks);
	DDX_Text(pDX, IDC_WRITE_LOCKS, m_WriteLocksStr);

}

BEGIN_MESSAGE_MAP(CReadWriteLockTestDlg, CDialog)
	//{{AFX_MSG_MAP(CReadWriteLockTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_READ_LOCK, OnReadLock)
	ON_BN_CLICKED(IDC_WRITE_LOCK, OnWriteLock)
	ON_BN_CLICKED(IDC_READ_UNLOCK, OnReadUnlock)
	ON_BN_CLICKED(IDC_WRITE_UNLOCK, OnWriteUnlock)
	ON_BN_CLICKED(IDC_NEW_THREAD, OnNewThread)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadWriteLockTestDlg message handlers

BOOL CReadWriteLockTestDlg::OnInitDialog()
{
	m_ThreadType = m_bMainThread?"Main thread":"Aux thread";
    CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReadWriteLockTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReadWriteLockTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReadWriteLockTestDlg::OnReadLock() 
{
    UpdateData(TRUE);
    m_State = "Waiting for read lock...";
    UpdateData(FALSE);
    CWaitCursor Wait;

    if (theApp.m_Lock.LockRead(m_Timeout))
    {
        m_State = "HAS READ LOCK";
        ++m_ReadLocks;
        GetDlgItem(IDC_READ_UNLOCK)->EnableWindow(TRUE);
    }
    else
        m_State = "Failed!";

    SetForegroundWindow();
    UpdateData(FALSE);
}

void CReadWriteLockTestDlg::OnWriteLock() 
{
    UpdateData(TRUE);
    m_State = "Waiting for write lock...";
    UpdateData(FALSE);
    CWaitCursor Wait;
    if (theApp.m_Lock.LockWrite(m_Timeout))
    {
        m_State = "HAS WRITE LOCK";
        ++m_WriteLocks;
        GetDlgItem(IDC_WRITE_UNLOCK)->EnableWindow(TRUE);
    }
    else
        m_State = "Failed!";
    SetForegroundWindow();
    UpdateData(FALSE);
}

void CReadWriteLockTestDlg::OnReadUnlock() 
{
    UpdateData(TRUE);
    if (theApp.m_Lock.UnlockRead(m_Timeout))
    {
        m_State = "Release read lock";
        if (--m_ReadLocks == 0)
            GetDlgItem(IDC_READ_UNLOCK)->EnableWindow(FALSE);
    }
    else
        m_State = "Failed!";

    UpdateData(FALSE);
}

void CReadWriteLockTestDlg::OnWriteUnlock() 
{
    UpdateData(TRUE);
    if (theApp.m_Lock.UnlockWrite(m_Timeout))
    {
        m_State = "Release write lock";
        if (--m_WriteLocks == 0)
            GetDlgItem(IDC_WRITE_UNLOCK)->EnableWindow(FALSE);
    }
    else
        m_State = "Failed!";

    UpdateData(FALSE);
}

void CReadWriteLockTestDlg::OnNewThread() 
{
    AfxBeginThread(RUNTIME_CLASS(CAdditionalThread));
}


HBRUSH CReadWriteLockTestDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
    switch (pWnd->GetDlgCtrlID())
    {
        case IDC_STATE:
            {
                if (m_State == "HAS READ LOCK")
                {
                    pDC->SetTextColor( RGB(255,255,255) ); // white
                    pDC->SetBkColor( RGB(0,128,0) ); // dark green
                };
            
                if (m_State == "HAS WRITE LOCK")
                {
                    pDC->SetTextColor (RGB(255,255,255) ); // white
                    pDC->SetBkColor( RGB(255,0,0) );     // red
                }

                if (m_State == "Waiting for read lock...")
                {
                    pDC->SetBkColor( RGB(160,255,160) ); // greenish
                }

                if (m_State == "Waiting for write lock...")
                {
                    pDC->SetBkColor( RGB(255,160,160) ); // reddish
                }

                if (m_State == "Failed!")
                {
                    pDC->SetBkColor( RGB(160,160,255) ); // bluish
                }
            };
            break;

        case IDC_READ_LOCKS:
            if (m_ReadLocks != 0)
            {
                pDC->SetTextColor( RGB(0,128,0) ); // green
            };
            break;

        case IDC_WRITE_LOCKS:
            if (m_WriteLocks != 0)
            {
                pDC->SetTextColor( RGB(255,0,0) ); // red
            };
            break;
    }

	return hbr;
}
